﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace CToDo
{
    public partial class frmMain : Form
    {
        public string strXmlFileName { get; set; }
        public string strNodeFileName { get; set; }

        public frmMain()
        {
            InitializeComponent();
        }
        private string loadBody(string strFileName)
        {
            string dwData = "";
            if (strFileName != "")
            {
                if (System.IO.File.Exists(strFileName) == true)
                {
                    System.IO.StreamReader sr = new System.IO.StreamReader(strFileName, System.Text.Encoding.GetEncoding("shift_jis"));
                    //内容をすべて読み込む
                    dwData = sr.ReadToEnd();
                    //閉じる
                    sr.Close();
                }
            }
            return dwData;
        }
        private string loadFileName()
        {
            string myFolder = System.IO.Path.GetDirectoryName(strXmlFileName);
            string myFileName = myFolder + @"\" + System.IO.Path.GetFileNameWithoutExtension(strXmlFileName) + ".todo";
            //
            return myFileName;
        }
        private void frmInit()
        {
            string strFileName = loadFileName();
            if ( System.IO.File.Exists(strFileName) )
            {
                string strBody = loadBody(strFileName);
                string[] strLines = strBody.Split(new string[] { "\r\n" }, StringSplitOptions.None);
                foreach (string strLine in strLines)
                {
                    if (strLine != "")
                    {
                        string[] strValues = strLine.Split(',');
                        if( strValues.Length == 3 )
                        {
                            string strRun = strValues[0];
                            string strData = strValues[1];
                            string strDate = strValues[2];
                            //
                            bool bSet = true;
                            if( strRun == "1" )
                            {
                                bSet = true;
                            }
                            else
                            {
                                bSet = false;
                            }
                            //
                            DateTime dt = DateTime.Now;
                            try
                            {
                                dt = DateTime.Parse(strDate);
                            }
                            catch
                            {

                            }
                            //
                            ListViewItem item = listItem(bSet, strData, dt);
                            if ( item != null )
                            {
                                listView.Items.Add(item);
                            }
                        }
                    }
                }
            }
            else
            {

            }
        }
        private ListViewItem listItem(bool bRun, string strBody, DateTime dt)
        {
            ListViewItem item = new ListViewItem();
            //
            bool bRet = true;
            //
            item.Text = "";
            item.Checked = bRun;
            //
            if (strBody != "")
            {
                item.SubItems.Add(strBody);
            }
            else
            {
                bRet = false;
            }
            try
            {
                item.SubItems.Add(dt.Date.ToString("yyyy/MM/dd"));
                TimeSpan ts = dt - DateTime.Now;
                //
                int iDay = ts.Days;
                //
                if (iDay < 0)
                {
                    // 期限を過ぎた
                    item.ForeColor = Color.Black;
                    item.BackColor = Color.OrangeRed;
                }
                else if (iDay == 0)
                {
                    item.ForeColor = Color.Red;
                }
                else if (iDay <= 3)
                {
                    item.ForeColor = Color.Fuchsia;
                }
                else if (iDay <= 10)
                {
                    item.ForeColor = Color.RoyalBlue;
                }
                else if (iDay <= 30)
                {
                    item.ForeColor = Color.SlateGray;
                }
                else
                {
                    item.ForeColor = Color.Black;
                }
            }
            catch
            {
                item = null;
            }
            //
            if( bRet == false )
            {
                item = null;
            }
            //
            return item;
        }
        private void frmMain_Load(object sender, EventArgs e)
        {
            listView.CheckBoxes = true;
            frmInit();
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            if (listView.SelectedItems.Count == 0)
            {

            }
            else
            {
                ListViewItem item = listView.SelectedItems[0];
                item.Remove();
            }
        }

        private void btnAdd_Click(object sender, EventArgs e)
        {
            frmToDo mToDo = new frmToDo();
            if( mToDo.ShowDialog() ==DialogResult.OK )
            {
                ListViewItem item = listItem(mToDo.bRun, mToDo.strBody, mToDo.dtRun);
                if (item != null)
                {
                    listView.Items.Add(item);
                }
            }
        }

        private void btnEdit_Click(object sender, EventArgs e)
        {
            if( listView.SelectedItems.Count == 0 )
            {

            }
            else
            {
                ListViewItem item = listView.SelectedItems[0];
                frmToDo mToDo = new frmToDo();
                mToDo.bRun = item.Checked;
                mToDo.strBody = item.SubItems[1].Text;
                mToDo.dtRun = DateTime.Parse(item.SubItems[2].Text);
                mToDo.RefreshX();
                if (mToDo.ShowDialog() == DialogResult.OK)
                {
                    ListViewItem rItem = listItem(mToDo.bRun, mToDo.strBody, mToDo.dtRun);
                    if (rItem != null)
                    {
                        int iPos = item.Index;
                        listView.Items[iPos] = rItem;
                    }
                }
            }
        }

        private void frmMain_FormClosing(object sender, FormClosingEventArgs e)
        {
            string strSave = "";
            foreach (ListViewItem item in listView.Items)
            {
                if (item.Checked == true)
                {
                    strSave = strSave + "1,";
                }
                else
                {
                    strSave = strSave + "0,";
                }
                //
                strSave = strSave + item.SubItems[1].Text.Replace(",", "") + ",";
                strSave = strSave + item.SubItems[2].Text + "\r\n";
            }
            if (strSave == "")
            {

            }
            else
            {
                string dwDataFileName = loadFileName();
                System.IO.StreamWriter sw = new System.IO.StreamWriter(dwDataFileName, false, System.Text.Encoding.GetEncoding("shift_jis"));
                //TextBox1.Textの内容を書き込む
                sw.Write(strSave);
                //閉じる
                sw.Flush();
                sw.Close();
                sw.Dispose();
            }
            DialogResult = DialogResult.OK;
        }

        private void frmMain_Resize(object sender, EventArgs e)
        {
            int iWidth = this.Width;
            if( iWidth > 200 )
            {
                //50
                // n
                //100
                //36
                colBody.Width = iWidth - (50 + 100 + 36);
            }
        }
    }
}
