﻿using CPlugIn;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace CClipboard
{
    public class CClipboard : IStoryEditorPlugin
    {
        public string Version
        {
            get
            {
                return "1.0.0.1";
            }
        }

        public bool isConfig
        {
            get
            {
                return true;
            }
        }

        public string Copyright
        {
            get
            {
                return "2018 北きつね";
            }
        }

        public bool isNodeOpen
        {
            get
            {
                return false;
            }
        }

        public DialogResult config(string strDllFileName)
        {
            CConfig mConfig = new CConfig();
            return mConfig.ShowDialog();
        }

        public bool init(string strDllFileName)
        {
            return true;
        }

        private ToolStripMenuItem getMenu(string menuText, string menuTool, string strDllFile, string strImageFile)
        {
            ToolStripMenuItem item = new ToolStripMenuItem();
            item.Text = menuText;
            item.ToolTipText = menuTool;
            Image img = getIcon(strDllFile, strImageFile);
            if (img != null)
            {
                item.Image = getIcon(strDllFile,strImageFile);
            }
            item.Tag = strDllFile;
            //
            return item;
        }
        private Image getIcon(string strDllFile, string strImageFile)
        {
            Image img = null;
            string myIconFile = System.IO.Path.GetDirectoryName(strDllFile) + @"\" + strImageFile;
            if (System.IO.File.Exists(myIconFile))
            {
                img = Bitmap.FromFile(myIconFile);
            }
            //
            return img;
        }

        public ToolStripMenuItem menu(string strDllFileName)
        {
            return getMenu("クリップボード", "クリップボードにテキスト形式でコピー", strDllFileName, "Clipboard.png");
        }
        public ToolStripMenuItem configMenu(string strDllFileName)
        {
            return getMenu("クリップボード", "クリップボード関連設定", strDllFileName, "Clipboard.png"); 
        }

        public CStoryEditorPlugin run(CStoryEditorPlugin mPluginData)
        {
            bool bError = false;
            CStoryEditorPlugin retData = mPluginData;
            //
            if (mPluginData.strXmlFileName != "")
            {
                if (System.IO.File.Exists(mPluginData.strXmlFileName))
                {
                    string dwDataFileName = System.IO.Path.GetDirectoryName(mPluginData.strXmlFileName) + "\\" + mPluginData.strNodeFileName;
                    if (System.IO.File.Exists(dwDataFileName) == true)
                    {
                        System.IO.StreamReader sr = new System.IO.StreamReader(dwDataFileName, System.Text.Encoding.GetEncoding("shift_jis"));
                        //内容をすべて読み込む
                        string dwData = sr.ReadToEnd();
                        //閉じる
                        sr.Close();
                        //
                        Clipboard.SetText(dwData);
                        bError = true;
                    }
                }
            }
            if( bError == false )
            {
                retData.result= DialogResult.No;
            }
            else
            {
                retData.result = DialogResult.OK;
            }
            return retData;
        }
    }
}
