﻿using CPlugIn;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace CNarou
{
    public class CNarou : IStoryEditorPlugin
    {
        public string Version
        {
            get
            {
                return "1.0.0.1";
            }
        }

        public bool isConfig
        {
            get
            {
                return true;
            }
        }

        public string Copyright
        {
            get
            {
                return "2018 北きつね";
            }
        }

        public bool isNodeOpen
        {
            get
            {
                return false;
            }
        }

        public DialogResult config(string strDllFileName)
        {
            CConfig mConfig = new CConfig();
            return mConfig.ShowDialog();
        }

        public bool init(string strDllFileName)
        {
            // 初期化の必要がなければ、True だけを返す
            return true;
        }

        private ToolStripMenuItem getMenu(string menuText, string menuTool, string strDllFile, string strImageFile)
        {
            ToolStripMenuItem item = new ToolStripMenuItem();
            item.Text = menuText;
            item.ToolTipText = menuTool;
            Image img = getIcon(strDllFile, strImageFile);
            if (img != null)
            {
                item.Image = getIcon(strDllFile, strImageFile);
            }
            item.Tag = strDllFile;
            //
            return item;
        }
        private Image getIcon(string strDllFile, string strImageFile)
        {
            Image img = null;
            string myIconFile = System.IO.Path.GetDirectoryName(strDllFile) + @"\" + strImageFile;
            if (System.IO.File.Exists(myIconFile))
            {
                img = Bitmap.FromFile(myIconFile);
            }
            //
            return img;
        }

        public ToolStripMenuItem menu(string strDllFileName)
        {
            return getMenu("テキスト", "テキスト形式のままエクスポートを行う", strDllFileName, "narou.png");
        }
        public ToolStripMenuItem configMenu(string strDllFileName)
        {
            return getMenu("テキストエクスポート", "標準エクスポート設定", strDllFileName, "narou.png");
        }

        public CStoryEditorPlugin run(CStoryEditorPlugin mPluginData)
        {
            CStoryEditorPlugin ret = mPluginData;
            //
            frmMain mApp = new frmMain();
            mApp.strXmlFileName = mPluginData.strXmlFileName;
            mApp.strNodeFileName = mPluginData.strNodeFileName;
            //
            ret.result = mApp.ShowDialog();
            //
            return ret;
        }
    }
}
