﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace CNarou
{
    public partial class frmMain : Form
    {
        public string strXmlFileName { get; set; }
        public string strNodeFileName { get; set; }

        public frmMain()
        {
            InitializeComponent();
        }
        private void frmInit()
        {
            if (strXmlFileName != "")
            {
                if (System.IO.File.Exists(strXmlFileName))
                {
                    string dwDataFileName = System.IO.Path.GetDirectoryName(strXmlFileName) + "\\" + strNodeFileName;
                    if (System.IO.File.Exists(dwDataFileName) == true)
                    {
                        System.IO.StreamReader sr = new System.IO.StreamReader(dwDataFileName, System.Text.Encoding.GetEncoding("shift_jis"));
                        //内容をすべて読み込む
                        string dwData = sr.ReadToEnd();
                        //閉じる
                        sr.Close();
                        //
                        txtBody.Text = dwData;
                    }
                }
            }
        }
        private void frmMain_Load(object sender, EventArgs e)
        {
            frmInit();
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;
            this.Close();
        }

        private void btnAbout_Click(object sender, EventArgs e)
        {
            CConfig mConfig = new CConfig();
            mConfig.ShowDialog();
        }

        private void btnClipboard_Click(object sender, EventArgs e)
        {
            string dwData = txtBody.Text;
            Clipboard.SetText(dwData);
        }

        private void btnFile_Click(object sender, EventArgs e)
        {
            if (System.IO.File.Exists(strXmlFileName))
            {
                string dwDataFileName = System.IO.Path.GetDirectoryName(strXmlFileName) + "\\" + strNodeFileName;
                if (System.IO.File.Exists(dwDataFileName) == true)
                {
                    SaveFileDialog sfd = new SaveFileDialog();
                    sfd.FileName = "newfile.txt";
                    //sfd.InitialDirectory = @"C:\";
                    sfd.Filter = "Textファイル(*.txt)|*.txt|すべてのファイル(*.*)|*.*";
                    sfd.FilterIndex = 2;
                    sfd.Title = "保存先のファイルを選択してください";
                    //ダイアログボックスを閉じる前に現在のディレクトリを復元するようにする
                    sfd.RestoreDirectory = true;
                    sfd.OverwritePrompt = true;
                    sfd.CheckPathExists = true;

                    //ダイアログを表示する
                    if (sfd.ShowDialog() == DialogResult.OK)
                    {
                        //OKボタンがクリックされたとき、選択されたファイル名を表示する
                        System.IO.File.Copy(dwDataFileName, sfd.FileName, true);
                    }
                }
            }
        }
    }
}
